# Ogre::OverlayManager Class Reference

Manages Overlay objects, parsing them from .overlay files and storing a lookup library of them. More...

`#include <OgreOverlayManager.h>`

Inheritance diagram for Ogre::OverlayManager:

[legend]
List of all members.

## Public Types

typedef std::map< String, Overlay * > | OverlayMap
typedef std::map< String, OverlayElement * > | ElementMap
typedef MapIterator< OverlayMap > | OverlayMapIterator
typedef MapIterator< ElementMap > | TemplateIterator

## Public Member Functions

| OverlayManager ()
virtual | ~OverlayManager ()
const StringVector & | getScriptPatterns (void) const

Remarks:
  This method is called when a resource group is loaded if you use ResourceGroupManager::_registerScriptLoader.

Returns:
  A list of file patterns, in the order they should be searched in.

void | parseScript (DataStreamPtr &stream, const String &groupName)

Parameters:

  | stream | Weak reference to a data stream which is the source of the script
  | groupName | The name of a resource group which should be used if any resources are created during the parse of this script.

Real | getLoadingOrder (void) const

Remarks:
  There are dependencies between some kinds of scripts, and to enforce this all implementors of this interface must define a loading order.

Returns:
  A value representing the relative loading order of these scripts compared to other script users, where higher values load later.

Overlay * | create (const String &name)
| Create a new Overlay.
Overlay * | getByName (const String &name)
| Retrieve an Overlay by name.
void | destroy (const String &name)
| Destroys an existing overlay by name.
void | destroy (Overlay *overlay)
| Destroys an existing overlay.
void | destroyAll (void)
| Destroys all existing overlays.
OverlayMapIterator | getOverlayIterator (void)
void | _queueOverlaysForRendering (Camera *cam, RenderQueue *pQueue, Viewport *vp)
| Internal method for queueing the visible overlays for rendering.
bool | hasViewportChanged (void) const
| Method for determining if the viewport has changed dimensions.
int | getViewportHeight (void) const
| Gets the height of the destination viewport in pixels.
int | getViewportWidth (void) const
| Gets the width of the destination viewport in pixels.
Real | getViewportAspectRatio (void) const
OverlayElement * | createOverlayElement (const String &typeName, const String &instanceName, bool isTemplate=false)
| Creates a new OverlayElement of the type requested.
OverlayElement * | getOverlayElement (const String &name, bool isTemplate=false)
| Gets a reference to an existing element.
void | destroyOverlayElement (const String &instanceName, bool isTemplate=false)
| Destroys a OverlayElement.
void | destroyOverlayElement (OverlayElement *pInstance, bool isTemplate=false)
| Destroys a OverlayElement.
void | destroyAllOverlayElements (bool isTemplate=false)
| Destroys all the OverlayElement created so far.
void | addOverlayElementFactory (OverlayElementFactory *elemFactory)
| Registers a new OverlayElementFactory with this manager.
OverlayElement * | createOverlayElementFromTemplate (const String &templateName, const String &typeName, const String &instanceName, bool isTemplate=false)
OverlayElement * | cloneOverlayElementFromTemplate (const String &templateName, const String &instanceName)
OverlayElement * | createOverlayElementFromFactory (const String &typeName, const String &instanceName)
TemplateIterator | getTemplateIterator ()
| Returns an iterator over all templates in this manager.
bool | isTemplate (String strName) const

## Static Public Member Functions

static OverlayManager & | getSingleton (void)
| Override standard Singleton retrieval.
static OverlayManager * | getSingletonPtr (void)
| Override standard Singleton retrieval.

## Protected Types

typedef std::map< String, OverlayElementFactory * > | FactoryMap
typedef std::set< String > | LoadedScripts

## Protected Member Functions

void | parseNewElement (DataStreamPtr &chunk, String &elemType, String &elemName, bool isContainer, Overlay *pOverlay, bool isTemplate, String templateName=String(""), OverlayContainer *container=0)
void | parseAttrib (const String &line, Overlay *pOverlay)
void | parseElementAttrib (const String &line, Overlay *pOverlay, OverlayElement *pElement)
void | skipToNextCloseBrace (DataStreamPtr &chunk)
void | skipToNextOpenBrace (DataStreamPtr &chunk)
bool | parseChildren (DataStreamPtr &chunk, const String &line, Overlay *pOverlay, bool isTemplate, OverlayContainer *parent=NULL)
ElementMap & | getElementMap (bool isTemplate)
OverlayElement * | createOverlayElementImpl (const String &typeName, const String &instanceName, ElementMap &elementMap)
OverlayElement * | getOverlayElementImpl (const String &name, ElementMap &elementMap)
void | destroyOverlayElementImpl (const String &instanceName, ElementMap &elementMap)
void | destroyOverlayElementImpl (OverlayElement *pInstance, ElementMap &elementMap)
void | destroyAllOverlayElementsImpl (ElementMap &elementMap)

## Protected Attributes

OverlayMap | mOverlayMap
StringVector | mScriptPatterns
int | mLastViewportWidth
int | mLastViewportHeight
bool | mViewportDimensionsChanged
FactoryMap | mFactories
ElementMap | mInstances
ElementMap | mTemplates
LoadedScripts | mLoadedScripts

## Static Protected Attributes

static OverlayManager * | ms_Singleton

## Detailed Description

Manages Overlay objects, parsing them from .overlay files and storing a lookup library of them.

Alo manages the creation of OverlayContainers and OverlayElements, used for non-interactive 2D elements such as HUDs.

Definition at line 45 of file OgreOverlayManager.h.

## Member Typedef Documentation

typedef std::map<String, OverlayElement*> Ogre::OverlayManager::ElementMap

| Definition at line 49 of file OgreOverlayManager.h.

typedef std::map<String, OverlayElementFactory*> Ogre::OverlayManager::FactoryMap`[protected]`

| Definition at line 67 of file OgreOverlayManager.h.

typedef std::set<String> Ogre::OverlayManager::LoadedScripts`[protected]`

| Definition at line 73 of file OgreOverlayManager.h.

typedef std::map<String, Overlay*> Ogre::OverlayManager::OverlayMap

| Definition at line 48 of file OgreOverlayManager.h.

typedef MapIterator<OverlayMap> Ogre::OverlayManager::OverlayMapIterator

| Definition at line 114 of file OgreOverlayManager.h.

typedef MapIterator<ElementMap> Ogre::OverlayManager::TemplateIterator

| Definition at line 184 of file OgreOverlayManager.h.

## Constructor & Destructor Documentation

Ogre::OverlayManager::OverlayManager | ( |  | ) |

virtual Ogre::OverlayManager::~OverlayManager | ( |  | ) | `[virtual]`

## Member Function Documentation

void Ogre::OverlayManager::_queueOverlaysForRendering | ( | Camera * | cam,
|  | RenderQueue * | pQueue,
|  | Viewport * | vp
| ) |

| Internal method for queueing the visible overlays for rendering.

void Ogre::OverlayManager::addOverlayElementFactory | ( | OverlayElementFactory * | elemFactory | ) |

Registers a new OverlayElementFactory with this manager.

Remarks:
  Should be used by plugins or other apps wishing to provide a new OverlayElement subclass.

OverlayElement* Ogre::OverlayManager::cloneOverlayElementFromTemplate | ( | const String & | templateName,
|  | const String & | instanceName
| ) |

Remarks:
  Creates a new OverlayElement object from the specified template name. The new object's name, and all of it's children, will be instanceName/orignalName.

Overlay* Ogre::OverlayManager::create | ( | const String & | name | ) |

| Create a new Overlay.

OverlayElement* Ogre::OverlayManager::createOverlayElement | ( | const String & | typeName,
|  | const String & | instanceName,
|  | bool | isTemplate = `false`
| ) |

Creates a new OverlayElement of the type requested.

Remarks:
  The type of element to create is passed in as a string because this allows plugins to register new types of component.

Parameters:

  | typeName | The type of element to create.
  | instanceName | The name to give the new instance.

OverlayElement* Ogre::OverlayManager::createOverlayElementFromFactory | ( | const String & | typeName,
|  | const String & | instanceName
| ) |

OverlayElement* Ogre::OverlayManager::createOverlayElementFromTemplate | ( | const String & | templateName,
|  | const String & | typeName,
|  | const String & | instanceName,
|  | bool | isTemplate = `false`
| ) |

OverlayElement* Ogre::OverlayManager::createOverlayElementImpl | ( | const String & | typeName,
|  | const String & | instanceName,
|  | ElementMap & | elementMap
| ) | `[protected]`

void Ogre::OverlayManager::destroy | ( | Overlay * | overlay | ) |

| Destroys an existing overlay.

void Ogre::OverlayManager::destroy | ( | const String & | name | ) |

| Destroys an existing overlay by name.

void Ogre::OverlayManager::destroyAll | ( | void |  | ) |

| Destroys all existing overlays.

void Ogre::OverlayManager::destroyAllOverlayElements | ( | bool | isTemplate = `false` | ) |

Destroys all the OverlayElement created so far.

Remarks:
  Best to leave this to the engine to call internally, there should rarely be a need to call it yourself.

void Ogre::OverlayManager::destroyAllOverlayElementsImpl | ( | ElementMap & | elementMap | ) | `[protected]`

void Ogre::OverlayManager::destroyOverlayElement | ( | OverlayElement * | pInstance,
|  | bool | isTemplate = `false`
| ) |

Destroys a OverlayElement.

Remarks:
  Make sure you're not still using this in an Overlay. If in doubt, let OGRE destroy elements on shutdown.

void Ogre::OverlayManager::destroyOverlayElement | ( | const String & | instanceName,
|  | bool | isTemplate = `false`
| ) |

Destroys a OverlayElement.

Remarks:
  Make sure you're not still using this in an Overlay. If in doubt, let OGRE destroy elements on shutdown.

void Ogre::OverlayManager::destroyOverlayElementImpl | ( | OverlayElement * | pInstance,
|  | ElementMap & | elementMap
| ) | `[protected]`

void Ogre::OverlayManager::destroyOverlayElementImpl | ( | const String & | instanceName,
|  | ElementMap & | elementMap
| ) | `[protected]`

Overlay* Ogre::OverlayManager::getByName | ( | const String & | name | ) |

Retrieve an Overlay by name.

Returns:
  A pointer to the Overlay, or 0 if not found

ElementMap& Ogre::OverlayManager::getElementMap | ( | bool | isTemplate | ) | `[protected]`

Real Ogre::OverlayManager::getLoadingOrder | ( | void |  | ) | const`[virtual]`

Remarks:
  There are dependencies between some kinds of scripts, and to enforce this all implementors of this interface must define a loading order.

Returns:
  A value representing the relative loading order of these scripts compared to other script users, where higher values load later.

Implements Ogre::ScriptLoader.

OverlayElement* Ogre::OverlayManager::getOverlayElement | ( | const String & | name,
|  | bool | isTemplate = `false`
| ) |

| Gets a reference to an existing element.

OverlayElement* Ogre::OverlayManager::getOverlayElementImpl | ( | const String & | name,
|  | ElementMap & | elementMap
| ) | `[protected]`

OverlayMapIterator Ogre::OverlayManager::getOverlayIterator | ( | void |  | ) |

const StringVector& Ogre::OverlayManager::getScriptPatterns | ( | void |  | ) | const`[virtual]`

Remarks:
  This method is called when a resource group is loaded if you use ResourceGroupManager::_registerScriptLoader.

Returns:
  A list of file patterns, in the order they should be searched in.

Implements Ogre::ScriptLoader.

static OverlayManager& Ogre::OverlayManager::getSingleton | ( | void |  | ) | `[static]`

Override standard Singleton retrieval.

Remarks:
  Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll.

  This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors.

Reimplemented from Ogre::Singleton< OverlayManager >.

static OverlayManager* Ogre::OverlayManager::getSingletonPtr | ( | void |  | ) | `[static]`

Override standard Singleton retrieval.

Remarks:
  Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll.

  This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors.

Reimplemented from Ogre::Singleton< OverlayManager >.

TemplateIterator Ogre::OverlayManager::getTemplateIterator | ( |  | ) |

| Returns an iterator over all templates in this manager. Definition at line 186 of file OgreOverlayManager.h.

Real Ogre::OverlayManager::getViewportAspectRatio | ( | void |  | ) | const

int Ogre::OverlayManager::getViewportHeight | ( | void |  | ) | const

| Gets the height of the destination viewport in pixels.

int Ogre::OverlayManager::getViewportWidth | ( | void |  | ) | const

| Gets the width of the destination viewport in pixels.

bool Ogre::OverlayManager::hasViewportChanged | ( | void |  | ) | const

Method for determining if the viewport has changed dimensions.

Remarks:
  This is used by pixel-based OverlayElements to work out if they need to reclaculate their sizes.

bool Ogre::OverlayManager::isTemplate | ( | String | strName | ) | const

| Definition at line 191 of file OgreOverlayManager.h.

void Ogre::OverlayManager::parseAttrib | ( | const String & | line,
|  | Overlay * | pOverlay
| ) | `[protected]`

bool Ogre::OverlayManager::parseChildren | ( | DataStreamPtr & | chunk,
|  | const String & | line,
|  | Overlay * | pOverlay,
|  | bool | isTemplate,
|  | OverlayContainer * | parent = `NULL`
| ) | `[protected]`

void Ogre::OverlayManager::parseElementAttrib | ( | const String & | line,
|  | Overlay * | pOverlay,
|  | OverlayElement * | pElement
| ) | `[protected]`

void Ogre::OverlayManager::parseNewElement | ( | DataStreamPtr & | chunk,
|  | String & | elemType,
|  | String & | elemName,
|  | bool | isContainer,
|  | Overlay * | pOverlay,
|  | bool | isTemplate,
|  | String | templateName = `String("")`,
|  | OverlayContainer * | container = `0`
| ) | `[protected]`

void Ogre::OverlayManager::parseScript | ( | DataStreamPtr & | stream,
|  | const String & | groupName
| ) | `[virtual]`

Parameters:

  | stream | Weak reference to a data stream which is the source of the script
  | groupName | The name of a resource group which should be used if any resources are created during the parse of this script.

Implements Ogre::ScriptLoader.

void Ogre::OverlayManager::skipToNextCloseBrace | ( | DataStreamPtr & | chunk | ) | `[protected]`

void Ogre::OverlayManager::skipToNextOpenBrace | ( | DataStreamPtr & | chunk | ) | `[protected]`

## Member Data Documentation

FactoryMap Ogre::OverlayManager::mFactories`[protected]`

| Definition at line 68 of file OgreOverlayManager.h.

ElementMap Ogre::OverlayManager::mInstances`[protected]`

| Definition at line 70 of file OgreOverlayManager.h.

int Ogre::OverlayManager::mLastViewportHeight`[protected]`

| Definition at line 61 of file OgreOverlayManager.h.

int Ogre::OverlayManager::mLastViewportWidth`[protected]`

| Definition at line 61 of file OgreOverlayManager.h.

LoadedScripts Ogre::OverlayManager::mLoadedScripts`[protected]`

| Definition at line 74 of file OgreOverlayManager.h.

OverlayMap Ogre::OverlayManager::mOverlayMap`[protected]`

| Definition at line 51 of file OgreOverlayManager.h.

OverlayManager * Ogre::Singleton< OverlayManager >::ms_Singleton`[static, protected, inherited]`

| Definition at line 61 of file OgreSingleton.h.

StringVector Ogre::OverlayManager::mScriptPatterns`[protected]`

| Definition at line 52 of file OgreOverlayManager.h.

ElementMap Ogre::OverlayManager::mTemplates`[protected]`

| Definition at line 71 of file OgreOverlayManager.h.

bool Ogre::OverlayManager::mViewportDimensionsChanged`[protected]`

| Definition at line 62 of file OgreOverlayManager.h.

The documentation for this class was generated from the following file:

- OgreOverlayManager.h

Copyright © 2000-2005 by The OGRE Team
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Mon Aug 20 13:53:42 2007